      SUBROUTINE MONA(NN,JPP,KX,JERR,NBAN,NER,KWAN,LAVA,JLACK)
CC
CC   MONOTHETIC ANALYSIS
CC
CC   PROGRAM FOR DIVISIVE HIERARCHICAL CLUSTERING OF BINARY DATA,
CC   USING ASSOCIATION ANALYSIS.
CC
CC   LIST OF FUNCTIONS AND SUBROUTINES:
CC       FUNCTION KAB 
CC
CC   THE FOLLOWING VECTORS AND MATRICES MUST BE DIMENSIONED IN THE
CC   MAIN PROGRAM:
CC       NBAN(NN),NER(NN),KWAN(NN),LAVA(NN)
CC       KX(NN,JPP)
CC       JLACK(JPP)
CC   WHERE:
CC          NN = NUMBER OF OBJECTS 
CC          JPP = NUMBER OF VARIABLES
CC
      DIMENSION NBAN(NN),NER(NN),KWAN(NN),LAVA(NN)
      DIMENSION JLACK(JPP)
      INTEGER KX(NN,JPP),NZF
CC
      LACK=0
      JHALT=0 
      NNHAL=(NN+1)/2
      JPTWE=(JPP+4)/5 
      MYST=0
      DO 70 L=1,NN
      MYSCA=0 
      DO 60 J=1,JPP 
      IF(KX(L,J).EQ.0)GO TO 60
      IF(KX(L,J).EQ.1)GO TO 60
      MYSCA=MYSCA+1 
   60 CONTINUE
      MYST=MYST+MYSCA 
      IF(MYSCA.NE.JPP)GO TO 70
CC   ALL VARIABLES MISSING FOR THIS OBJECT
      JHALT=1 
      JERR=1
   70 CONTINUE
      IF(JHALT.EQ.1)RETURN
      IF(MYST.EQ.0)GO TO 290
      DO 100 J=1,JPP
      JNUL=0
      JEEN=0
      DO 80 L=1,NN
      IF(KX(L,J).EQ.0)JNUL=JNUL+1
      IF(KX(L,J).EQ.1)JEEN=JEEN+1
   80 CONTINUE
      JLACK(J)=NN-JNUL-JEEN 
      IF(JLACK(J).NE.0)LACK=LACK+1
      IF(JLACK(J).LT.NNHAL)GO TO 90 
CC   AT LEAST 50% OF THE OBJECTS HAVE MISSING VALUES FOR THIS VARIABLE
      JHALT=1
      JERR=2
   90 IF(JNUL.EQ.0)GO TO 95 
      IF(JEEN.EQ.0)GO TO 95 
      GO TO 100 
CC   ALL NON MISSING VALUES ARE IDENTICAL FOR THIS VARIABLE
   95 JHALT=1
      JERR=3
  100 CONTINUE
      IF(JHALT.EQ.0)GO TO 110 
      RETURN
  110 JPRES=JPP-LACK
      IF(JPRES.NE.0)GO TO 200 
CC   ALL VARIABLES HAVE MISSING VALUES       
      JERR=4
      RETURN
CC
CC   FILLING IN MISSING VALUES
CC
  200 DO 260 J=1,JPP
      IF(JLACK(J).EQ.0)GO TO 260
      LAMA=-1 
      NSYN=1
      DO 240 JA=1,JPP 
      IF(JLACK(JA).NE.0)GO TO 240 
      JVA=0 
      JVB=0 
      JVC=0 
      JVD=0 
      DO 230 K=1,NN 
      IF(KX(K,J).EQ.1)GO TO 220
      IF(KX(K,JA).EQ.0)JVA=JVA+1
      IF(KX(K,JA).EQ.1)JVB=JVB+1
      GO TO 230
  220 IF(KX(K,JA).EQ.0)JVC=JVC+1
      IF(KX(K,JA).EQ.1)JVD=JVD+1
  230 CONTINUE
      KAL=JVA*JVD-JVB*JVC
      KALF=KAB(KAL)
      IF(KALF.LT.LAMA)GO TO 240 
      LAMA=KALF 
      JMA=JA
      IF(KAL.LT.0)NSYN=-1
  240 CONTINUE
      DO 250 L=1,NN 
      IF(KX(L,J).EQ.0)GO TO 250
      IF(KX(L,J).EQ.1)GO TO 250
      IF(NSYN.EQ.1)THEN
         KX(L,J)=KX(L,JMA)
      ELSE
         IF(KX(L,JMA).EQ.1)KX(L,J)=0
         IF(KX(L,JMA).EQ.0)KX(L,J)=1
      ENDIF
  250 CONTINUE
  260 CONTINUE
CC
CC   INITIALIZATION 
CC
  290 DO 300 K=1,NN 
      KWAN(K)=0 
      NER(K)=K
      LAVA(K)=0 
  300 CONTINUE
      NPASS=1 
      KWAN(1)=NN
CC
CC   ALGORITHM
CC
      NCLU=1
      KA=1
  310 KB=KA+KWAN(KA)-1
      LAMA=-1 
      JNAT=JPP
      DO 370 J=1,JPP
      IF(NCLU.EQ.1)GO TO 330
      JNUL=0
      JEEN=0
      DO 325 L=KA,KB
      NEL=NER(L)
      IF(KX(NEL,J).EQ.0)JNUL=JNUL+1
      IF(KX(NEL,J).EQ.1)JEEN=JEEN+1
  325 CONTINUE
      IF(JEEN.EQ.0)GO TO 370
      IF(JNUL.EQ.0)GO TO 370
  330 JNAT=JNAT-1 
      LAMS=0
      DO 360 JB=1,JPP 
      IF(JB.EQ.J)GO TO 360
      KVA=0 
      KVB=0 
      KVC=0 
      KVD=0 
      DO 350 L=KA,KB
      NEL=NER(L)
      IF(KX(NEL,J).EQ.1)GO TO 340
      IF(KX(NEL,JB).EQ.0)KVA=KVA+1
      IF(KX(NEL,JB).EQ.1)KVB=KVB+1
      GO TO 350
  340 IF(KX(NEL,JB).EQ.0)KVC=KVC+1
      IF(KX(NEL,JB).EQ.1)KVD=KVD+1
  350 CONTINUE
      LAMS=LAMS+KAB(KVA*KVD-KVB*KVC)
  360 CONTINUE
      IF(LAMS.LE.LAMA)GO TO 370 
      JTEL=KVC+KVD
      JTELZ=KVA+KVB 
      LAMA=LAMS 
      JMA=J 
  370 CONTINUE
      IF(JNAT.LT.JPP)GO TO 375
      KWAN(KA)=-KWAN(KA)
      GO TO 400 
CC
CC    SPLITTING 
CC
  375 NEL=NER(KA)
      IF(KX(NEL,JMA).EQ.1)THEN
      NZF=0
      JTEL2=JTEL
      ELSE
      NZF=1
      JTEL2=JTELZ
      ENDIF
      JRES=KB-KA+1-JTEL2
      KM=KA+JTEL2
      L=KA
  378 NEL=NER(L)
      IF(KX(NEL,JMA).EQ.NZF)GO TO 380
      L=L+1 
      IF(L.LT.KM)GO TO 378
      GO TO 390 
  380 DO 381 LBB=L,KB 
      NELBB=NER(LBB)
      IF(KX(NELBB,JMA).EQ.NZF)GO TO 381
      LCC=LBB-1 
      GO TO 382 
  381 CONTINUE
  382 DO 383 LAA=L,LCC
      LDD=LCC+L-LAA 
      LEE=LDD+1 
      NER(LEE)=NER(LDD) 
  383 CONTINUE
      NER(L)=NELBB
      GO TO 378 
  390 NCLU=NCLU+1 
      NBAN(KM)=NPASS
      KWAN(KA)=JTEL2
      KWAN(KM)=JRES
      LAVA(KM)=JMA
      KA=KA+KWAN(KA)
  400 IF(KB.EQ.NN)GO TO 500 
  410 KA=KA+KAB(KWAN(KA)) 
      IF(KA.GT.NN)GO TO 500 
      IF(KWAN(KA).LT.2)GO TO 410
      GO TO 310 
  500 NPASS=NPASS+1 
      DO 510 KA=1,NN
      IF(KWAN(KA).GE.2)GO TO 310
  510 CONTINUE
      END 
CC  
CC
      FUNCTION KAB(J) 
      KAB=J 
      IF(J.LT.0)KAB=-J
      RETURN
      END
